/*  DeltaSMT: Delta-debugger for Satisfiablity Modulo Theories (SMT) benchmarks.
 *  Copyright (C) 2009  Robert Daniel Brummayer
 *
 *  This file is part of DeltaSMT.
 *
 *  DeltaSMT is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DeltaSMT is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class BVArrayType extends ArrayType
{

  public BVArrayType (BVType indexType, BVType elementType){
    super (indexType, elementType);
    assert (indexType != null);
    assert (elementType != null);
  }

  public String toString (){
    return "Array["+ ((BVType) super.indexType).getWidth() + ":" + 
            ((BVType) super.elementType).getWidth() + "]";
  }

  public int hashCode(){
    return ((BVType) super.indexType).getWidth() +
           ((BVType) super.elementType).getWidth();
  }

  public int getIndexWidth(){
    return ((BVType) super.indexType).getWidth();
  }

  public int getElementWidth(){
    return ((BVType) super.elementType).getWidth();
  }

}
