/*  DeltaSMT: Delta-debugger for Satisfiablity Modulo Theories (SMT) benchmarks.
 *  Copyright (C) 2009  Robert Daniel Brummayer
 *
 *  This file is part of DeltaSMT.
 *
 *  DeltaSMT is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DeltaSMT is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class Token
{

  public TokenKind kind;
  public int line;
  public int col;
  public String str;

  public Token (TokenKind kind, int line, int col){
    assert (kind != null);
    assert (line >= 0);
    assert (col >= 0);
    this.kind = kind;
    this.line = line;
    this.col = col;
    this.str = "";
  }

  public Token (TokenKind kind, int line, int col, String str){
    assert (kind != null);
    assert (str != null);
    assert (line >= 0);
    assert (col >= 0);
    this.kind = kind;
    this.line = line;
    this.col = col;
    this.str = str;
  }

  public String toString(){
    return this.kind + " " + this.line + " " + this.col + " " + this.str;
  }

  public boolean equals(Object o)
  {
    if (!(o instanceof Token))
      return false;

    return this.equals ((Token) o);
  }

  public boolean equals(Token t) {
    return this.kind == t.kind && this.line == t.line && 
           this.col == t.col && this.str.equals(t.str);
  }

}
